#!/bin/bash
# lastact: arturo@2025-02-13
# desc: script bash de generación de vx-ipxe-full.ipxe

NOMBRE="vx-ipxe-restore"
CONT=1
IPS_CACHE=( 10.0.21.1 172.16.0.249 172.16.4.249 172.30.0.250 172.30.1.249 172.30.1.252 172.30.164.150 172.30.2.249 172.30.2.90 172.30.3.241 172.30.3.249 172.30.3.253 172.30.3.90 172.30.4.249
    172.30.4.2 172.30.4.50 172.31.249.249 192.168.0.249 192.168.10.249 192.168.123.90 192.168.1.249 192.168.1.2 192.168.13.249 192.168.159.249 192.168.21.1 192.168.2.249 192.168.28.249 192.168.
3.249 192.168.3.254 192.168.4.100 192.168.4.249 192.168.4.90 192.168.4.99 192.168.5.249 192.168.60.249 192.168.6.249 192.168.7.249 migasfree.educa.aragon.es )
IPCACHE_DEFAULT="172.30.1.249"
[[ -z "${IPCACHE}" ]] && IPCACHE="${IPCACHE_DEFAULT}"

cat <<EOF> "vx-ipxe-full.ipxe"
#!ipxe
# Script ipxe generado como resultado de la ejecución de vx-ipxe-full.ipxe.sh
# Damos la oportunidad al usuario de entrar en la shell o seguir con el arranque ipxe programado:
echo > Vamos a arrancar via iPXE y restaurar el sistema. Puedes cancelar el proceso pulsando Ctrl-B:
# prompt --key 0x02 --timeout 2000 Press Ctrl-B for the iPXE command line... && shell ||
prompt --key 0x02 --timeout 3000 Pulsa Ctrl-B para acceder a la CommandLine de iPXE shell... || goto continuar
shell
exit

:continuar
dhcp || goto errorred
echo > Configuracion DHCP Terminada - La direccion IP del equipo es:
isset \${ip} && show ip
set ipcache ${IPCACHE}
echo > Comprobamos que hay conectividad con el servidor cache del centro:
ping --count 2 \${ipcache} || goto siguiente1
chain http://${IPCACHE}/ipxe-boot/${NOMBRE}.ipxe?ipcache=${IPCACHE} ipcache=${IPCACHE}
# ${NOMBRE}.ipxe recibirá un parámetro \${ipcache}: isset \${ipcache} && echo "La IP del caché es \${ipcache}"
exit

$(for IP in "${IPS_CACHE[@]}" ; do
echo ":siguiente${CONT}
set ipcache ${IP}
echo > Probamos con la IP del cache: \${ipcache}
ping --count 2 \${ipcache} || goto siguiente$(( CONT + 1 ))
chain http://\${ipcache}/ipxe-boot/${NOMBRE}.ipxe?ipcache=\${ipcache} ipcache=\${ipcache}
exit"

(( CONT++ ))
done)

:errorred
echo > Error: No se ha podido configurar el equipo correctamente por DHCP
shell
exit
EOF